# coding=utf-8
from base.APIConstants import Constants
from base.APISenderBase import Base


class APITag(Base):
    """
    标签管理API(tag manage class)
    构造方法接收两个参数:
    @:param secret 必填 - APP_SECRET
    @:param token 可选 - authToken,发送消息时需带该参数以进行鉴权操作，调用鉴权接口获得
    """

    def add_tag(self, tag_message, retry_times=3):
        """
        新建标签
        :param tag_message: 消息体(请求参数对象)
        :param retry_times: 重试次数
        """
        return self._try_http_request(Constants.request_path.ADD_TAG, retry_times, **tag_message)

    def update_tag(self, tag_message, retry_times=3):
        """
        更新标签
        :param tag_message: 消息体(请求参数对象)
        :param retry_times: 重试次数
        """
        return self._try_http_request(Constants.request_path.UPDATE_TAG, retry_times, **tag_message)

    def add_members(self, tag_message, retry_times=3):
        """
        给标签天机用户设备
        :param tag_message: 消息体(请求参数对象)
        :param retry_times: 重试次数
        """
        return self._try_http_request(Constants.request_path.ADD_MEMBERS, retry_times, **tag_message)

    def remove_members(self, tag_message, retry_times=3):
        """
        从标签中移除用户设备
        :param tag_message: 消息体(请求参数对象)
        :param retry_times: 重试次数
        """
        return self._try_http_request(Constants.request_path.REMOVE_MEMBERS, retry_times, **tag_message)

