# coding=utf-8
from base.APIConstants import Constants
from base.APISenderBase import Base


class APITagGroup(Base):
    """
    标签分类管理API(tag group manage class)
    构造方法接收两个参数:
    @:param secret 必填 - APP_SECRET
    @:param token 可选 - authToken,发送消息时需带该参数以进行鉴权操作，调用鉴权接口获得
    """

    def add_tag_group(self, tag_group_message, retry_times=3):
        """
        新建标签分类
        :param tag_group_message: 消息体(请求参数对象)
        :param retry_times: 重试次数
        """
        return self._try_http_request(Constants.request_path.ADD_TAG_GROUP, retry_times, **tag_group_message)

    def update_tag_group(self, tag_group_message, retry_times=3):
        """
        更新标签分类
        :param tag_group_message: 消息体(请求参数对象)
        :param retry_times: 重试次数
        """
        return self._try_http_request(Constants.request_path.UPDATE_TAG_GROUP, retry_times, **tag_group_message)

    def add_tag_to_group(self, tag_group_message, retry_times=3):
        """
        添加标签到标签分类中
        :param tag_group_message: 消息体(请求参数对象)
        :param retry_times: 重试次数
        """
        return self._try_http_request(Constants.request_path.ADD_TAG_TO_GROUP, retry_times, **tag_group_message)


