# coding=utf-8
from base.APIConstants import Constants
from base.APISenderBase import Base


class APITagSegment(Base):
    """
    标签组合管理API(tag segment manage class)
    构造方法接收两个参数:
    @:param secret 必填 - APP_SECRET
    @:param token 可选 - authToken,发送消息时需带该参数以进行鉴权操作，调用鉴权接口获得
    """

    def add_tag_segment(self, tag_segment_message, retry_times=3):
        """
        新建标签组合
        :param tag_segment_message: 消息体(请求参数对象)
        :param retry_times: 重试次数
        """
        return self._try_http_request(Constants.request_path.ADD_TAG_SEGMENT, retry_times, **tag_segment_message)

    def update_tag_segment(self, tag_segment_message, retry_times=3):
        """
        更新标签组合
        :param tag_segment_message: 消息体(请求参数对象)
        :param retry_times: 重试次数
        """
        return self._try_http_request(Constants.request_path.UPDATE_TAG_SEGMENT, retry_times, **tag_segment_message)